%smooth.m version c
%AR octobre 1996 - aout 2003
echo on
% permette la correzione automatica di alcuni errori 
% nella curva di F0 ottenuta con FOF - traccia la curva
% e permette di salvarla in un file .dfo
echo off

fostars=zeros(1,xvectsize);

for n=1:xvectsize; 
	tvoiced(n)=t(n);
	if voiced(xvect(n))<5000 ;
		tvoiced(n)=0;
	end;
end;

for n=1:xvectsize; 
	if tvoiced(n)>0;
		fostars(n)=16000/tvoiced(n);
	end;
end;

figure(1)
fomax=max(fostars);
yrange=[-40 fomax+50];
tax=[1 xvectsize yrange];

%%%%%%%%%%%%%%%%CORRECT%%%%%%%%%%%%%%%

smflag=0; %begin sm loop
smflag = input('Correggere la curva? (y/n) [default y]: ', 's');
if isempty(smflag), smflag = 'y'; end;

if smflag == 'y';

s=0;
num=1;
for n=1:xvectsize; 
	if fostars(n)>0; s=s+fostars(n); num=num+1; end;
end;
av=s/num;

%riposiziona mediando valori troppo alti o troppo bassi
for n=2:xvectsize-1; 
	if fostars(n)>10 & fostars(n-1)>10 & (fostars(n)>1.4*av | fostars(n)<0.6*av) ;
		fostars(n)=(fostars(n-1)+fostars(n+1))/2;
	end;
end;

%riposiziona mediando valori interni troppo bassi
for n=2:xvectsize-2;
	if fostars(n)<10 & fostars(n-1)>0 & fostars(n+1)>0;
			fostars(n)=(fostars(n-1)+fostars(n+1))/2;
	end;
end;

%riposiziona mediando valori troppo diversi da prec. e succ.
for n=2:xvectsize-1; 
	if fostars(n)>10 & fostars(n-1)>10 & (fostars(n)>1.2*fostars(n-1) | fostars(n)<0.8*fostars(n-1)) & (fostars(n)>1.2*fostars(n+1) | fostars(n)<0.8*fostars(n+1)) ;
		fostars(n)=(fostars(n-1)+fostars(n+1))/2;
	end;
end;

%riposiziona primi valori troppo alti rispetto alla media dei valori seguenti
for n=3:xvectsize-3;
	if fostars(n-1)<10 & fostars(n)>10 & fostars(n+1)>10 & fostars(n+2)>10 & fostars(n+3)>10 ;
		if fostars(n)>1.05*(fostars(n+1)+fostars(n+2)+fostars(n+3))/3 ;
			fostars(n)=(fostars(n+1)+fostars(n+2)+fostars(n+3))/3;
		end;
	end;
end;

%riposiziona primi valori troppo bassi rispetto alla media dei valori seguenti
for n=3:xvectsize-3;
	if fostars(n-1)<10 & fostars(n)>10 & fostars(n+1)>10 & fostars(n+2)>10 ;
		if fostars(n)<0.95*(fostars(n+1)+fostars(n+2)+fostars(n+3))/3 ;
			fostars(n)=(fostars(n+1)+fostars(n+2)+fostars(n+3))/3;
		end;
	end;
end;

%riposiziona 
%for n=3:xvectsize-2;
	%if (fostars(n-1)>0 & fostars(n-2)>0) & fostars(n+1)>0 & fostars(n+2)>0 ;
		%if fostars(n)<0.6*fostars(n-1) | fostars(n)>1.4*fostars(n-1) ;
			%fostars(n)=(fostars(n-1)+fostars(n+1))/2;
		%end;
	%end;
%end;

%%%%%%%%%%%%%%%ReDet BLOCKS%%%%%%%%%%%%%%%%

joinflag=0; %begin join loop
%joinflag = input('Congiungere blocks? (y/n) [default y]: ', 's');
if isempty(joinflag), joinflag = 'n'; end;

if joinflag == 'y';

zi=0;
zf=0;

n=1;
m=1;
for i=2:xvectsize;
	if fostars(i)>1 & fostars(i-1)<1; zi(n)=i; n=n+1; end;
	if fostars(i)<1 & fostars(i-1)>1; zf(m)=i; m=m+1; end;
end;

blocknbr=size(zi,2);

for n=1:blocknbr;
	nbr2(n)=zf(n)-zi(n);
	data=0;
	forward=0;
	backward=0;
	for i=1:nbr2(n)-1;
		data(i)=fostars(zi(n)+i-1);
		forward(i)=data(i);
		backward(i)=data(i);
	end;
	for i=1:floor(nbr2(n)/2)-1;
		forward(2*i)=(data(2*i-1)+data(2*i+1))/2;
	end;
	for i=1:floor(nbr2(n)/2)-2;
		backward(2*i+1)=(data(2*i)+data(2*i+2))/2;
	end;
	mid=(forward+backward)/2;
	for i=1:nbr2(n)-1;
		fostars(zi(n)+i-1)=mid(i);
	end;
end;

end; %join loop

end; %sm loop

%%%%%%%%%%%%%%%ExTEND%%%%%%%%%%%%%%%%

fosmooth=zeros(1,sigsize);

for n=2:xvectsize-1; 
	for m=xvect(n-1)':xvect(n)';
		fosmooth(m)=fostars(n-1);
	end;
end;

for n=1:sigsize; 
	fosmooth(n)=fosmooth(n)*voiced(n)/10000;
end;

figure(1)
fomax=max(fosmooth);
yrange=[-20 fomax+50];
tax=[1 sigsize yrange];
subplot(2,1,2),hold on,plot(fosmooth(1:sigsize),'b-'),axis(tax),hold off


%%%%%%%%%%%%%%%SALVA%%%%%%%%%%%%%%%%%

saveflag=0;
saveflag = input('Salvare file .dfo ? (y/n) [default y]: ', 's');
if isempty(saveflag), saveflag = 'y'; end;

if saveflag == 'y';
	whichfile = input('File? (*.dfo) ', 's');
	fofile=whichfile;
end;

if saveflag == 'y';
	fid = fopen(fofile,'w');
	fwrite(fid,sigsize,'int32');
	fwrite(fid,blocknbr,'int32');
	fwrite(fid,xvectsize,'int32');
	fwrite(fid,block,'int32');
	fwrite(fid,xvect,'int32');
	fwrite(fid,fostars,'int32');
	fclose(fid);
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear('y');
clear('sigzero');
clear('hpsig');
clear('hpsigzero');
clear('backward');
clear('forward');
%pack;
