%fo.m version c
%AR octobre 1996 - aout 2003
echo on
% fornisce una stima di F0 nelle aree selezionate 
% su un oscillogramma (mediante VUNV) - traccia la curva
% e lascia in memoria xvect, xvectsize, tvoiced
% permette la scelta di una frequenza di taglio (fc)
% adatta alla voce da analizzare (oppure due fc in due regioni 
% caratterizzate da diverso registro
echo off

[B,A] = butter(4,50/8000,'high');
sigzero = [sig;zeros(4,1)];
hpsig = filter(B,A,sigzero);

freqkind = input('Una o due regioni di definizione di fc? (1/2) [default 1]: ', 's');
if isempty(freqkind), freqkind = '1'; end;

if freqkind=='1';

	fc = input('fc [120]: ');
	if isempty(fc), fc = 120; end;

	[B,A] = butter(6,fc/8000);
	hpsigzero = [hpsig;zeros(6,1)];
	ybut = filter(B,A,hpsigzero);

else

	message=sprintf('%s','  Cliccare sull''oscill. per def. le separaz. tra le due regioni')
	figure(1);
	breaky = ginput(1);
	breaky(2) = breaky(1);

	fc1 = input('fc1 [120]: ');
	if isempty(fc1), fc1 = 120; end;
	fc2 = input('fc2 [120]: ');
	if isempty(fc2), fc2 = 120; end;

	sig1=hpsig(1:breaky(1));
	sig2=hpsig(breaky(1):sigsize);

	[B,A] = butter(6,fc1/8000);
	hpsigzero = [sig1;zeros(6,1)];
	ybut1 = filter(B,A,hpsigzero);
	[B,A] = butter(6,fc2/8000);
	hpsigzero = [sig2;zeros(6,1)];
	ybut2 = filter(B,A,hpsigzero);
        ybut=[ybut1' ybut2'];

end;

x=zeros(1,sigsize);

for n=2:sigsize; 
	if (ybut(n-1)<-0.01 & ybut(n)>0.01);
		x(n)=1;
	end;
end;

xvect=find(x>0);
xvectsize=size(xvect,2);
t=zeros(1,xvectsize);

for n=2:xvectsize; 
	t(n)=xvect(n)-xvect(n-1);
end;

for n=1:xvectsize; 
	tvoiced(n)=t(n);
	if voiced(xvect(n))<5000 ;
		tvoiced(n)=0;
	end;
end;

to=zeros(1,sigsize);
foplot=zeros(1,sigsize);

for n=2:xvectsize; 
	if voiced(xvect(n))>5000 ;
		for m=xvect(n-1)':xvect(n)';
			to(m)=tvoiced(n-1);
		end;
	end;
end;

for n=1:sigsize; 
	if to(n)>0;
		foplot(n)=16000/to(n);
	end;
end;

fomax=max(foplot);
yrange=[-20 fomax+50];
tax=[1 sigsize yrange];

figure(1)
set(gcf,'Position',[4 474 681 353],'Resize','on')
clf

subplot(2,1,1),plot(sig,'b-'),axis(ax)
set(gca,'FontName', 'Times','FontSize', 8);

subplot(2,1,1),hold on,plot(voiced,'y'),axis(ax),hold off
if signame(signamesize)=='f' & signame(signamesize-1)=='i' & signame(signamesize-2)=='a';
	title(signame(1:signamesize-4));
else title(signame); end;
ylabel('amplitude [ ]');

subplot(2,1,2),plot(foplot(1:sigsize),'g-'),axis(tax)
set(gca,'FontName', 'Times','FontSize', 8);

xlabel('smpls [ ]');
ylabel('Fo [Hz]');

clear('A');
clear('B');
clear('sigzero');
clear('hpsig');
clear('hpsigzero');
clear('x');
clear('x1');
clear('xrange');
clear('yrange');
clear('ybut');
clear('to');
clear('foplot');
clear('fomax');
clear('i','j','m','n');

%close(1);
