%readtxt
%M-file
%AR aout 1997

echo on
% This program draws fo textfiles 
% (.txt files generated by a text editor)
echo off

signame = input('Introduce the name of the file (*.txt): ', 's');
if isempty(signame), signame = 'a.txt'; end

fid = fopen(signame,'r');
filestr=fscanf(fid,'%s',1);
sizestr=fscanf(fid,'%s',1);
sigsize=fscanf(fid,'%d',1);
datestr=fscanf(fid,'%s',1);
dstr=fscanf(fid,'%s',1);
msstr=fscanf(fid,'%s',1);
enstr=fscanf(fid,'%s',1);
dBstr=fscanf(fid,'%s',1);
fo1str=fscanf(fid,'%s',1);
fo2str=fscanf(fid,'%s',1);
fo3str=fscanf(fid,'%s',1);
Hzstr=fscanf(fid,'%s',1);

data=fscanf(fid,'%d');

otherstr=fscanf(fid,'%s',1);
otherstr=fscanf(fid,'%s',1);
datafox=fscanf(fid,'%d');

fclose(fid);

datasize=size(data,1);
blocknbr=datasize/6;
dataout=0;

for i=1:blocknbr;
	block(i)=data(6*i-5);
	durations(i)=data(6*i-4);
	energies(i)=data(6*i-3);
	datafoy(3*i-2)=data(6*i-2);
	datafoy(3*i-1)=data(6*i-1);
	datafoy(3*i)=data(6*i);
end;

for i=1:blocknbr*3;
	dataout(2*i-1)=datafox(i);
	dataout(2*i)=datafoy(i);
end;

dataout(blocknbr*6+1)=sigsize;
for k=1:blocknbr;
	dataout(blocknbr*6+1+k)=energies(k);
end;

% written data structure of a .mdl
%
%	blocknbr*6 values of Fo (three pairs of x-values/y-values for each block)
%	sigsize
%	blocknbr values of erg
%	end.
%
% to get blocknbr read data determine their size (datanbr)
% and calculate (datanbr-1)/7.

datanbr=size(dataout,2);
blocknbr=(datanbr-1)/7;
datanbr=datanbr-blocknbr;

datafox(1)=0;
datafoy(1)=0;
for i=2:(datanbr-1)/2+1;
	datafox(i)=dataout(2*(i-1)-1);
	datafoy(i)=dataout(2*(i-1));
end;
datafox((datanbr-1)/2+2)=dataout(datanbr);
datafoy((datanbr-1)/2+2)=0;

sigsize=datafox((datanbr-1)/2+2);

for i=1:blocknbr;
	ergval1(i)=dataout(datanbr+i);
end;

fomax=max(datafoy);
yrange=[-40 fomax+50];
tax=[1 sigsize yrange];
%plot(datafox,datafoy,'o'),axis(tax)

fo5=zeros(1,sigsize);
for i=2:(datanbr-1)/2+1;
	fo5(datafox(i))=datafoy(i);
end;

for i=1:(datanbr-1)/6;
	for j=datafox(3*i-1)+1:datafox(3*i);
		fo5(j)=fo5(datafox(3*i-1))+(j-datafox(3*i-1)+1)*(fo5(datafox(3*i))-fo5(datafox(3*i-1)))/((datafox(3*i))-(datafox(3*i-1)));
	end;
	for j=datafox(3*i)+1:datafox(3*i+1);
		fo5(j)=fo5(datafox(3*i))+(j-datafox(3*i)+1)*(fo5(datafox(3*i+1))-fo5(datafox(3*i)))/((datafox(3*i+1))-(datafox(3*i)));
	end;
end;

figure(3)
set(gcf,'Position',[10 571 678 255],'Resize','on')
clf;
fomax=max(fo5);
yrange=[-40 fomax+50];
tax=[1 sigsize yrange];
plot(fo5(1:sigsize),'r-'),axis(tax)

signamesize=size(signame,2);
if signame(signamesize)=='f' & signame(signamesize-1)=='i' & signame(signamesize-2)=='a';
	title(signame(1:signamesize-4));
else title(signame); end;

xlabel('samples []');
ylabel('Fo [Hz]');

sum=0;
nbr=0;
fomin=30000;
fomax=-30000;
for i=1:sigsize;
	if fo5(i)>0.1; 
		if fo5(i)>fomax; fomax=fo5(i) ; end;
		if fo5(i)<fomin; fomin=fo5(i) ; end;
		sum=sum+fo5(i); 
		nbr=nbr+1; 
	end;
end;

avfo=sum/nbr;
fominstr= [num2str(fomin) ' Hz'];
text(sigsize+50,fomin,fominstr);
avfostr=[num2str(avfo) ' Hz'];
text(sigsize+50,avfo,avfostr);
fomaxstr=[num2str(fomax) ' Hz'];
text(sigsize+50,fomax,fomaxstr);

clear('fo5')
