%sigdfo.m
%AR febbraio 2004
%graphiques en dB entre 50 et 120 environ 
%graphiques en Hz entre 150 et 350 environ 
%legge nuovi dfo salvati con dox a 32bit 

signame = input('Signal [albahar.aif]: ', 's');
if isempty(signame), signame = 'albahar.aif'; end

fid=fopen(signame);
sigtemp = fread(fid,inf,'int16');
fclose(fid);
sigtempsize = size(sigtemp,1);

xzoom=30:sigtempsize-300;
sig = sigtemp(xzoom);
sigsize = size(sig,1);
xrange=[0 sigsize];
yrange=[-36000 36000];
ax=[xrange yrange];

clear('sigtemp');

figure(1)
set(gcf,'Position',[10 10 678 716],'Resize','on')
clf

subplot(3,1,1),plot(sig,'b'),axis(ax)
set(gca,'FontName', 'Times','FontSize', 8);

signamesize=size(signame,2);
if signame(signamesize)=='f' & signame(signamesize-1)=='i' & signame(signamesize-2)=='a';
	title(signame(1:signamesize-4));
else title(signame); end;

ylabel('Amp. Ist. [ ]');

sound(sig/max(sig),16000);

maxcount=2*floor(sigsize/160);
erg=zeros(1,maxcount-1);
widerg=zeros(1,sigsize);
count=1;
windsig=sig(1:160);
erg(count)=10*log10(windsig'*windsig+1);
	
for count=2:maxcount-1;
	windsig=sig((count-1)*80+1:(count+1)*80);
	erg(count)=10*log10(windsig'*windsig+1);
end;

for count=1:maxcount-1;
	for i=1:160; widerg((count-1)*80+i)=erg(count); end;
end;

ergmax=max(erg);
ergmin=min(erg);
widerg=widerg-ergmin;
widergmax=max(widerg);
widergax=[1 sigsize 10 widergmax+10];

subplot(3,1,2),plot(widerg,'b'), axis(widergax)
set(gca,'FontName', 'Times','FontSize', 8);

ylabel('Energia [dB]');

sigstr = input('Introduce the filename of the *.dfo file to be opened: ', 's');

	fid=fopen(sigstr);

	if fid>0;
		dfo = fread(fid,inf,'int32');
		fclose(fid);

		if dfo(1)<0; dfo(1)=65536+dfo(1); end;
		sigsize=dfo(1);
		blocknbr=dfo(2);
		vectsize=dfo(3);

		flag=0;
		block(1)=dfo(1+3);
		for i=2:blocknbr*2;
			block(i)=dfo(i+3);
			if block(i)<0; block(i)=65536+block(i); end;
			if block(i-1)>block(i); flag=1; block(i)=65536+block(i); end;
		end;

		vect(1)=dfo(1+3+blocknbr*2);
		for i=2:vectsize;
			vect(i)=dfo(i+3+blocknbr*2);
			if vect(i)<0; vect(i)=65536+vect(i); end;
			fostars(i)=dfo(i+3+blocknbr*2+vectsize);
		end;

		for i=2:vectsize;
			if vect(i-1)>vect(i); flag=1; vect(i)=65536+vect(i); end;
		end;

		t=zeros(1,vectsize);
		for n=2:vectsize; 
			t(n)=vect(n)'-vect(n-1);
		end;

		if flag==1; sigsize=sigsize+65536; end;
		voiced=zeros(1,sigsize);
		for j=1:blocknbr;
			for i=block(2*j-1):block(2*j);
				voiced(i)=10000; 
			end;	  
		end;

		tvoiced=zeros(1,vectsize);
		for n=1:vectsize; 
			tvoiced(n)=t(n);
			if voiced(vect(n))<5000 ;
				tvoiced(n)=0;
			end;
		end;

		fopost=zeros(1,vectsize);
			for n=1:vectsize; 
				if tvoiced(n)>0;
					fopost(n)=16000/tvoiced(n);
				end;
		end;

		fobest=zeros(1,sigsize);
		for n=2:vectsize-1; 
			if voiced(vect(n))>5000 | (voiced(vect(n-1))>5000 & voiced(vect(n+1))>5000);
				for m=vect(n-1)':vect(n)';
					fobest(m)=fostars(n-1);
				end;
			end;
		end;

	end;

fomax=max(fostars);

subplot(3,1,3),plot(fobest,'b.'),axis([1 size(sig,1) 50 450]);
set(gca,'FontName', 'Times','FontSize', 8);

xlabel('campioni [ ]');
ylabel('Fo [Hz]');

clear('x');
clear('xb');
clear('xrange');
clear('yrange');
clear('xzoom');
clear('message');
clear('clickflag');
clear('fobest');
clear('fopost');
clear('fostars');
clear('fid');
clear('sigtempsize');
clear('voicekind');
clear('erg');
clear('widerg');

